"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.gitCommitBumpPublish = void 0;
const devopsCore_1 = require("@thatdevops/core/devopsCore");
const echo_1 = __importDefault(require("@thatdevops/core/utils/echo"));
const lerna_1 = __importDefault(require("@thatdevops/core/utils/lerna"));
const makeRunable_1 = require("@thatdevops/core/utils/makeRunable");
const spawn_1 = __importDefault(require("@thatdevops/core/utils/spawn"));
const doNothing_1 = __importDefault(require("@thats/utils/misc/doNothing"));
const doResyncPackages_1 = __importDefault(require("./_/doResyncPackages"));
exports.gitCommitBumpPublish = (0, makeRunable_1.makeRunnable)((o) => __awaiter(void 0, void 0, void 0, function* () {
    const { publishable } = (0, devopsCore_1.getDevOpsCore)();
    if (!publishable) {
        (0, echo_1.default)('Publishing not allowed (set the dev ops "publishable" flag');
        return;
    }
    (0, echo_1.default)('Resyncing Package versions');
    yield (0, doResyncPackages_1.default)(false);
    const premessage = 'Prepublish - ' + o.commitMessage + ' [skip-cd]';
    (0, echo_1.default)(`Committing "${premessage}"`);
    yield (0, spawn_1.default)('git', ['add', '-A']).catch(doNothing_1.default);
    yield (0, spawn_1.default)('git', ['commit', '-a', '-m', premessage]).catch(doNothing_1.default);
    (0, echo_1.default)('Running Lerna Publish');
    let params = ['patch', '--yes', '--no-push', '--exact'];
    if (o.force) {
        params.push('--force-publish');
    }
    (0, echo_1.default)(`lerna publish ${params.join(' ')}`);
    yield lerna_1.default.publish(params);
    const postmessage = 'Postpublish - ' + o.commitMessage + (o.deploy ? '' : ' [skip-cd]');
    (0, echo_1.default)(`Committing "${postmessage}"`);
    yield (0, spawn_1.default)('git', ['commit', '-a', '-m', postmessage]).catch(doNothing_1.default);
    (0, echo_1.default)(`Pushing to git`);
    yield (0, spawn_1.default)('git', ['push']).catch(doNothing_1.default);
}));
exports.default = exports.gitCommitBumpPublish;
